// main program
  gosub Initialization
  gosub Demo
end
//===================================================================
Initialization:
  Flip on
  graphX = 5
  graphY = 290
  speed = 0
  oldDcycle = 0
  mass=10
  friction = 1
  a=0
  BG = 10132122
  ClearScr BG
  FitBMP "Mot2",0,400,200,150
  LineWidth 2
  Rectangle 0,400,200,450,BG,BG
  Rectangle 130,400,450,750,BG,BG
  Rectangle 0,535,130,550,BG,BG
  Circle 300,350,500,550,Black,Gray
  Circle 395,445,405,455,Black,Black
  Line 90,490,350,363
  Line 90,515,373,547
  Rectangle 320,325,775,350,Black,Gray
  Rectangle 750,350,775,599,Black,Gray
  Circle 575,425,625,475,Black,DarkGray
  Line 600,350,600,425
  s=12
  Circle 92-s,502-s,92+s,502+s,Black,DarkGray
  Circle 90,500,94,504,Black,Black
  SetColor Black,BG
  xyString 382, 565, "MASS"
  xyString 570,530,"FRICTION"
  SaveScr 0,300,799,599
  LineWidth 10
  Rectangle 0,0,799,295,Blue,White
  AddButton "Heavy",305,565,70
  AddButton "Light",430,565,70
  AddButton "Large", 495,530,70
  AddButton "Small", 653,530,70
  Flip
  SetColor Black,White
  print
  print "  This demo runs a DC motor at full speed.  Change the size of the weight to alter the"
  print "  friction (which will alter the speed). Change the mass of the pulley to see how it"
  print "  affects how fast the motor can change speeds.  Your assignment is to alter this"
  print "  subroutine so that the motor will maintain a specified speed no matter what friction"
  print "  or mass is used.  To change the motor speed (under program control) set the variable"
  print "  dcycle (duty cycle of the PWM)and call the subroutine Motor.  After the call you can"
  print "  read the variable MotSpeed to find out the current motor speed.  Note: Since you can"
  print "  only set the duty cycle to integers from 0-15, your program should constantly alter"
  print "  the duty cycle to maintain any selected speed regardless of the mass or friction."
  print "  That after all, is the basis for this assignment.  A good program should be able to"
  print "  keep the motor at any given speed under any reasonable conditions.  GOOD LUCK!"
  print
  print "              Click the mouse in this window to start the demo."
  print
  print "    NOTE: You may PAUSE the demo by holding down the mouse button on the graph."
  Line 0,0,0,295,10,Blue
  flip
  repeat
    ReadMouse x,y,z
  until z>0
  Data GraphPaper;0,0,799,297,gray
  mGraphPaper GraphPaper
  flip  
return  
//===================================================================
Demo: 
  dcycle=12
  while true
    gosub Motor
  wend
return
//===================================================================
Motor:
  dcycle = round(dcycle)
  Torque = 1.0*(dcycle*1.7-friction*speed)
  speed = speed+Torque/mass
  t=290-speed*10
  LineWidth 2
  Line graphX,graphY,graphX+1,t,4
  graphX=graphX+1
  if graphX>795
    graphX = 5
    mGraphPaper GraphPaper
  endif
  graphY=t
  a=a+(speed*.05)
  RestoreScr 0,300
  if friction=5 then Circle 550,400,650,500,Black,DarkGray 
  if mass = 100 then  Circle 375,425,425,475,Black,Black
  LineWidth 2
  Line 92,502,92+12*cos(a),502+12*sin(a)
  Line 400,450,400+100*cos(a/20),450+100*sin(a/20)
  GetButton but
  if but = "Large" then friction = 5
  if but = "Small" then friction = 1
  if but = "Heavy" then mass = 100
  if but = "Light" then mass = 10
  SetColor Black,BG
  xyString 10,350,"Current speed = ",format(speed*20,"###0.00")
  MotSpeed=20*speed
  repeat
    ReadMouse xm,ym,mb
  until !(ym<296 and mb=1) 
  flip
return